/**
 **   simcity.h  data structures used by simcity save files
 **   Copyright Michael F. Horgan   12/23/90	e-mail: mike@ics.com
 **		Permission to use and modify for non-commercial purposes
 **		is hereby granted provided this notice remains intact.
 **/

typedef  unsigned short WORD;   	/* must be 16 bits */
typedef  unsigned long LONGINT;	/* must be 32 bits */

typedef  struct _simcityStateInfo {
	WORD 	filler;
	WORD  	ExtMktSize;
	WORD 	ResPop;
	WORD	ComPop;
	WORD	IndPop;
	WORD	ResVal;
	WORD	ComVal;
	WORD	IndVal;
	LONGINT	CityTime;
	WORD	CrimeRamp;
	WORD	PolluteRamp;
	WORD	LandValAvg;
	WORD	CrimeAvg;
	WORD	PollutionAvg;
	WORD	GameLevel;
	WORD	CityClass;
	WORD	CityScore;
	WORD	future_expansion[32];
	LONGINT	TotalFunds;
	WORD	AutoBull;
	WORD	AutoBudget;
	WORD	AutoGo;
	WORD	SoundEffects;
	WORD	TaxRate;
	WORD	SimSpeed;
	WORD	PoliceBudget;
	WORD	FireBudget;
	WORD	RoadBudget;
	WORD	future_expansion2[56];
} simcityStateInfo;
	

typedef struct _simcityDataFile {
	WORD	filler;
	char 	CityName[62];
	char	MacInfo[64];
	char 	ResHis[480];
	char 	ComHis[480];
	char	IndHis[480];
	char 	CrimeHis[480];
	char 	PollutionHis[480];
	char 	CashFlowHis[480];
	simcityStateInfo	State;
	/*  map info goes here, left out for now */
}  simcityDataFile;
