/**
 **   simhack.c -- program to hack sim city save files for additional money
 **   Copyright Michael F. Horgan   12/23/90	e-mail: mike@ics.com
 **		Permission to use and modify for non-commercial purposes
 **		is hereby granted provided this notice remains intact.
 **/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <conio.h>
#include "simcity.h"

#define BUFFER_LEN  28*1024
char   inbuffer[BUFFER_LEN];
char   swapbuffer[BUFFER_LEN];

main(int argc, char **argv)
{
	FILE 	*in, *out;
	long 	inlength;
	char   *tempFile, *saveFile;
	char  	outFile[1024], c;
	int	tmp, index;
	unsigned long newFunds, swaplong();
	simcityDataFile *simData, *rawSimData;

	if (argc != 2) {
		printf("usage:	%s  simcity_save_file.\n", argv[0]);
		exit(-1);
   	}

	if ((in = fopen(argv[1], "rb")) == (FILE *)NULL) {
		printf("Could not open SimCity save file %s.\n", argv[1]);
		}

	inlength = filelength(fileno(in));

	if((tmp = fread(inbuffer, sizeof(char), inlength, in)) != (int)inlength) {
		printf("Unexpected end of data file after %d bytes.\n", tmp);
		exit(-1);
		}
	fclose (in);
	/*
	 * convert data buffer to intel byte order
	 * SimCity is a port of a Mac (motorola) program
	 */
	swab(inbuffer, swapbuffer, BUFFER_LEN);
	simData = (simcityDataFile *)swapbuffer;
	rawSimData = (simcityDataFile *)inbuffer;

	printf("Well bud, looks like you've got %ld buckskins.\n",
				swaplong(simData->State.TotalFunds));
	printf("How much does a hard-working mayor like you DESERVE? ");
	scanf("%U", &newFunds);
	
	simData->State.TotalFunds = swaplong(newFunds);
	swab(swapbuffer, inbuffer, BUFFER_LEN);
	
	printf("\n\
There there.  You can now possess a version of '%s'\n\
with %ld SimDollars if you would be kind enough\n\
to provide your humble servant with a filename:\n\
[%s] -> ", rawSimData->CityName, newFunds, argv[1]);

	index =0;
	while ((c = (char) getche()) != '\r')
		outFile[index++] = c;
	outFile[index] = '\0';

	saveFile = (index)?outFile:argv[1];
	tempFile = tmpnam(NULL);

	if ((out = fopen(tempFile, "wb")) == (FILE *)NULL) {
		printf("Could not open temp file %s.\n", tempFile);
		exit(-1);
		}

	if((tmp = fwrite(inbuffer, sizeof(char), inlength, out)) != (int)inlength) {
		printf("Problem writing output file after %d bytes.\n", tmp);
		fclose(out);
		remove(tempFile);
		exit(-1);
		}
	fclose (out);

	if(remove(saveFile)) {
		if (errno == EACCES) {
			printf("Could not overwrite existing file %s\n", saveFile);
			exit(-1);
		}
	}
	
	if (rename(tempFile, saveFile)) {
		printf("Could not rename temp file.  New SimCity file is %s.",
				tempFile);
 	}
	printf("\nDone.\n");
}

unsigned long swaplong(unsigned long l)
{
	unsigned long tmp = l, result;
	result = (l << 16) | (tmp >> 16); 
	return (result);
}
